FROM multiarch/alpine:amd64-v3.8

RUN apk add --no-cache shadow

RUN groupadd -r prometheus && useradd -r -g prometheus prometheus

RUN mkdir -p /etc/prometheus && mkdir /prometheus && chown -R prometheus:prometheus /prometheus /etc/prometheus && chmod -R g+s /prometheus /etc/prometheus
 
VOLUME ["/etc/prometheus/"]

COPY prometheus-linux-amd64/prometheus /usr/local/bin/prometheus
COPY prometheus-linux-amd64/promtool /usr/local/bin/promtool
COPY ./conf/prometheus.yml /etc/prometheus/prometheus.yml
COPY prometheus-linux-amd64/console_libraries /usr/share/prometheus/console_libraries/
COPY prometheus-linux-amd64/consoles /usr/share/prometheus/consoles/

COPY entrypoint.sh /usr/local/bin/entrypoint.sh

RUN chmod +x /usr/local/bin/entrypoint.sh && chmod +x /usr/local/bin/prometheus && chmod +x /usr/local/bin/promtool

RUN ln -s /usr/share/prometheus/console_libraries /usr/share/prometheus/consoles/ /etc/prometheus/ && \
    mkdir -p /prometheus && \
    chown -R nobody:nogroup /etc/prometheus /prometheus && \
    ln -s /prometheus /etc/prometheus/data

USER       prometheus
EXPOSE     9090
WORKDIR    /etc/prometheus
ENTRYPOINT [ "entrypoint.sh" ]